use git2::Repository;

fn main() -> eyre::Result<()> {
    let repo = Repository::open(".git")?;
    let mut revwalk = repo.revwalk()?;
    revwalk.set_sorting(git2::Sort::TIME)?;

    let revspec = repo.revparse("HEAD")?;
    let from = revspec.from().ok_or(eyre::anyhow!("could not get HEAD"))?;
    revwalk.push(from.id())?;

    for rev in revwalk.enumerate() {
        let oid = rev.1?;
        let commit = repo.find_commit(oid)?;
        let message = commit
            .message()
            .ok_or(eyre::anyhow!("could not find message from commit"))?;
        println!("rev: {}", message)
    }

    Ok(())
}
